global HI
global MuI

for jj = 1:2^size(S,2)
    if (rem(jj,1000)==0)
        disp(sprintf('iter %d of %d',jj,2^size(S,2)))
    end
    x_0 = bitget(jj,[1:size(S,2)]);
    
%    x_0 = 0.5*ones(1,size(S,2));; % Starting values for the optimization.
    I = find(x_0>0);
    if (max(max(H(I,I)))>1e5)
        disp('incompatiable links are on. skipping')
        continue
    end
    
    % if x(i)~=0 then we can try to use it, so other links that block x(i) will be eliminated. We mark link to be eliminate from the optimization with -1
    % if x(i) ==0 and does not block any x(j)~=0, then it will remain
    for i = 1:size(x_0)
        if (x_0(i)~=0)
            I = find(H(i,:)>1e5 | H(:,i)'>1e5);
            x_0(I)=-1;
        end
    end
    % now make sure that the x(i)=0 are compatiable
    for i=1:size(x_0)
        if (x_0(i)==0)
            I = find(H(i,:)>1e5 | H(:,i)'>1e5);
            x_0(I)=-1;
        end
    end
    II = find(x_0~=-1);
    HI = H(II,II);
    MuI = Mu(II);
    x0I = x_0(II);
    x_L = 0*x0I; % Lower bounds for x.
    x_U = 1+0*x0I; % Upper bounds for x.
    fLowBnd = -inf; % Lower bound on function.
    Name = 'PowProblem';
    Prob = conAssign('ValUtility', 'GradUtil', 'HessianUtil', [], x_L, x_U, Name, x0I,[], [], [], [], [], [], [], [], [], [], []);
    Result = tomRun('ucSolve', Prob, 0); % Ignores constraints.
    x = zeros(size(S,1),1);
    x(II) = Result.x_k;
    vv = MakeS(ss,H,VScale);
    if (vv*Mu > max(V*Mu))
        disp('is better')
        vv*Mu - max(V*Mu)
    end
end

