

% find range of bit-rates for each link
MIN_INTERFERENCE = 1e-20; % 200dB interference is the same as zero
MakeRealSchSimple

%VMu = V*Mu;
%I = find(VMu >=max(VMu)-1e-2*max(VMu)); % fin
I = find(xx>0);
if (length(I)>size(V,2))
    disp('there are more active assignments than the number of links -  run remove redundancy')
end

clear BitRates
for k = 1:size(V,2)
    bb = sort(unique(V(I,k)));    
    BitRates{k} = [bb(2)/2, bb(2)];
    if (bb(2)*2 <= VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)))
        BitRates{k} = [BitRates{k}, bb(2)*2];
    else
        if (VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)) > max(BitRates{k}))
            BitRates{k} = [BitRates{k}, VScale*log(1 + H(i,i)/(MIN_INTERFERENCE+NOISE))];
        end
    end
        
    
    for i = 3:length(bb)
        if (bb(i)/2>1.2*max(BitRates{k}) && bb(i)/2<=VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)) )
            BitRates{k} = [BitRates{k}, bb(i)/2];
        end
         if (bb(i)>1.2*max(BitRates{k}) && bb(i)<VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)))
            BitRates{k} = [BitRates{k}, bb(i)];
        end
         if (bb(i)*2>1.2*max(BitRates{k}) && bb(i)*2<VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)) )
            BitRates{k} = [BitRates{k}, bb(i)*2];
        else
            if (bb(i)*2>VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE)) && VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE))>max(BitRates{k})) 
                BitRates{k} = [BitRates{k}, VScale*log(1 + H(k,k)/(MIN_INTERFERENCE+NOISE))];
            end
        end
    end
end
    
    
    