% clear BitRates  % BitRate{i} is the set of bit-rates that link i might transmit at
% for i=1:size(Links,1)
%     BitRates{i} = [1 2 4];  % the simple case where e3ach link transmits at 1 2 or 4 bps/hz
% end

clear MacroVertex % MacroVertex{i}{j} is the set of links that interfer with link i at bit rate j
GRWeights=[];
clear GRNeighbors
GRLink = [];
GRBR = [];
k=1;
for i=1:size(Links,1)
    for j=1:length(BitRates{i})
        GRWeights = [GRWeights;Mu(i)*BitRates{i}(j)];
        GRLink = [GRLink;i];
        GRBR = [GRBR;BitRates{i}(j)];
        GRNeighbors{k}=[];
        k=k+1;
    end
end
k=1;
for i=1:size(Links,1)
    for j=1:length(BitRates{i})
        MaxH = H(i,i)/(exp(BitRates{i}(j)/VScale)-1) - NOISE;
        % if log2(1 + H(i,i)/(H(n,i) + NOISE)) < Bitrate{i}(j) then n is a nighbor in the contension graph
        MacroVertex{i}{j} = i;  % a link interfers with the other bit-raes of the same link (a link can only transmit at a single bit-rate)
        Ind{i}(j) = k;
        k=k+1;
        for n=1:size(Links,1)
            if (H(n,i)>MaxH)
                MacroVertex{i}{j} = [MacroVertex{i}{j},n];
            end
        end
    end
end
k=1;
for i=1:size(Links,1)
    for j=1:length(BitRates{i})
        for m=1:length(MacroVertex{i}{j})
            for mm=1:length(Ind{MacroVertex{i}{j}(m)})            
                GRNeighbors{k} = [GRNeighbors{k},Ind{MacroVertex{i}{j}(m)}(mm)];         
            end
        end
        k=k+1;
    end
end

for k = 1:length(GRNeighbors)
    for i=1:length(GRNeighbors{k})
        if (max(GRNeighbors{GRNeighbors{k}(i)} == k)==0)
            GRNeighbors{GRNeighbors{k}(i)} = [GRNeighbors{GRNeighbors{k}(i)},k];
        end
    end
end
for k=1:length(GRNeighbors)
    GRNeighbors{k} = sort(GRNeighbors{k});
end


% graph is made
% now apply kako

NotAllowed = zeros(length(GRNeighbors),1);
Set = [];

while (min(NotAllowed)==0)    
    GRWD = zeros(length(GRNeighbors),1);
    for k=1:length(GRNeighbors)
        J = ismember(GRNeighbors{k}, find(NotAllowed==0));
        GRWD(k) = sum(GRWeights(GRNeighbors{k}(J)))/GRWeights(k);
    end
    I = find(GRWD==min(GRWD) & NotAllowed==0);
    I=I(1);
    Set = [Set,I];
    NotAllowed(I)=1;
    NotAllowed(GRNeighbors{I})=1;
end

ss = zeros(1,size(V,2));
ss(GRLink(Set))=1;
vv = MakeS(ss,H,VScale);




            



