function Q = EvalQ(Mu,V,Paths, FlowUsage)
if (min(Mu)<0)
    Q=inf;
else
    Vu = V*Mu;
    VMu = max(Vu);
    
    
    F=zeros(length(Paths),1);
    for i=1:length(Paths)
        f = sum(Mu(Paths{i}));
        if (f==0)
            Q = inf;
            return;
        end
        F(i) = 1/f;
    end
    
    Q = -sum(log(F));
    
    for i=1:length(Mu)
        Q = Q + Mu(i)*sum(F(FlowUsage{i}));
    end
    
    Q = Q -  VMu;   
    
    Q = -Q;
    
    %[Q,F']
end