function D = MakeAllProjections(Mu,v, zeroThresh)
% make all projected directions
J = find(Mu'<=zeroThresh & v<0);
if (length(J)>10)
    2^length(J)
    disp('attempting to make too many projections of a subgradient ... press any key to continue')    
    pause
end
D=v; % no zeros selection
% k=length(J) is all zeros selected
for k=1:length(J)
    JJ = nchoosek(J,k);
    for jj=1:size(JJ,1)
        vv = v;
        vv(JJ(jj,:))=0;
        D=[D;vv];
    end
end

    
    
    