% clear BitRates  % BitRate{i} is the set of bit-rates that link i might transmit at
% for i=1:size(Links,1)
%     BitRates{i} = [1 2 4];  % the simple case where e3ach link transmits at 1 2 or 4 bps/hz
% end

%FindRangeOfLinkBitRates

NotAllowed = [];%zeros(length(GRNeighbors),1);
Set = [];

while (length(NotAllowed)==0 || min(NotAllowed)==0)    
    clear MacroVertex % MacroVertex{i}{j} is the set of links that interfer with link i at bit rate j
    GRWeights=[];
    clear GRNeighbors
    clear Ind
    GRLink = [];
    GRBR = [];
    k=1;
    for i=1:size(Links,1)
        for j=1:length(BitRates{i})
            GRWeights = [GRWeights;Mu(i)*BitRates{i}(j)];
            GRLink = [GRLink;i];
            GRBR = [GRBR;BitRates{i}(j)];
            GRNeighbors{k}=[];
            k=k+1;
        end
    end
    if (length(NotAllowed)==0)
        NotAllowed = zeros(length(GRNeighbors),1);
    end
    k=1;
    for i=1:size(Links,1)
        for j=1:length(BitRates{i})
            MaxH = max(H(i,i)/(exp(BitRates{i}(j)/VScale)-1) - NOISE, 1e-20);
            % if log2(1 + H(i,i)/(H(n,i) + NOISE)) < Bitrate{i}(j) then n is a nighbor in the contension graph
            MacroVertex{i}{j} = i;  % a link interfers with the other bit-raes of the same link (a link can only transmit at a single bit-rate)
            Ind{i}(j) = k;
            k=k+1;
            for n=1:size(Links,1)
                if (H(n,i)+sum(H(GRLink(Set),i))>MaxH)
                    MacroVertex{i}{j} = [MacroVertex{i}{j},n];
                end
            end
        end
    end
    k=1;
    for i=1:size(Links,1)
        for j=1:length(BitRates{i})
            for m=1:length(MacroVertex{i}{j})
                for mm=1:length(Ind{MacroVertex{i}{j}(m)})            
                    GRNeighbors{k} = [GRNeighbors{k},Ind{MacroVertex{i}{j}(m)}(mm)];         
                end
            end
            k=k+1;
        end
    end
    
    
    for k = 1:length(GRNeighbors)
        for i=1:length(GRNeighbors{k})
            if (max(GRNeighbors{GRNeighbors{k}(i)} == k)==0)
                GRNeighbors{GRNeighbors{k}(i)} = [GRNeighbors{GRNeighbors{k}(i)},k];
            end
        end
    end
    for k=1:length(GRNeighbors)
        GRNeighbors{k} = sort(unique(GRNeighbors{k}));
        GRNeighbors{k} = GRNeighbors{k}(find(GRNeighbors{k}~=k));
    end
    
    
    GRWD = zeros(length(GRNeighbors),1);
    for k=1:length(GRNeighbors)
        if (GRWeights(k)~=0)
            J = ismember(GRNeighbors{k}, find(NotAllowed==0));        
            GRWD(k) = sum(GRWeights(GRNeighbors{k}(J)))/GRWeights(k);
        else
            GRWD(k) = inf;
        end
    end
    JJ = find(NotAllowed==0);
    if (min(GRWD(JJ))==inf)
        break;
    end
    I = JJ(find(GRWD(JJ)==min(GRWD(JJ))));
    I=I(1);
    Set = [Set,I];
    NotAllowed(I)=1;
    NotAllowed(GRNeighbors{I})=1;
end

ss = zeros(1,size(V,2));
ss(GRLink(Set))=1;
vv = MakeS(ss,H,VScale);
if (vv*Mu > max(V*Mu))
    fd=0;
    for in = 1:size(S,1)
        if (max(abs(S(in,:)-ss)) == 0)
            fd=1;
            break;
        end
    end
    if (fd==0)
        disp('found a new assignment');
        SECont = ss;
        VECont = vv;
        %    S=[S;ss];
        %   V=[V;vv];
        suc=1;
    else
        disp('new assignment was no better than the old ones')
        suc=0;
        SECont = 0;
        VECont = 0;
    end
else
    disp('new assignment was no better than the old ones')
    suc=0;
    SECont = 0;
    VECont = 0;
end








