% MakeLinkPairs
Alpha = 1;  % Threshold

% Only one link is on 
OneLinkAssign = eye(size(Links,1));
OneLinkAssignBW = MakeS(OneLinkAssign, H,VScale);
clear AL
clear NotAL
% Acceptable links for link i in the two links case
for i=1:size(Links,1)
    AL{i} = [];
    NotAL{i}=[];
end

for i=1:size(Links,1)-1
    for j=i+1:size(Links,1)
        TwoLinksAssign = OneLinkAssign(i,:) | OneLinkAssign(j,:);
        TwoLinksAssignBW = MakeS(TwoLinksAssign, H,VScale);
      %  if ((Alpha - TwoLinksAssignBW(i)/ OneLinkAssignBW(i,i)) * OneLinkAssignBW(j,j) < TwoLinksAssignBW(j))
        if ( (TwoLinksAssignBW(i)/ OneLinkAssignBW(i,i) +  TwoLinksAssignBW(j)/OneLinkAssignBW(j,j)) > Alpha)
            AL{i} = [AL{i}; j];
            AL{j} = [AL{j}; i];
        else
            NotAL{i} = [NotAL{i};j];
            NotAL{j} = [NotAL{i};i];
        end
    end   
end
