% SimpleKako

% see http://www.hi.is/~mmh/papers/WIS_WG.pdf for details

MakeLinkPairs

Allowed = [1:length(AL)];
Set = [];
LSet = zeros(1,length(AL));
while (1)
    AL_V = zeros(length(AL),1);
    for ii=1:length(Allowed)    
        i = Allowed(ii);
        Intf = sum(H(Set,i));
        AL_V(i) = log( 1 + H(i,i)/(Intf+NOISE) );
    end
    AL_WD = zeros(length(AL),1);
    for ii = 1:length(Allowed)
        i = Allowed(ii);
        if (AL_V(i)*Mu(i) == 0 )
            AL_WD(i) = inf;
        else
            AL_WD(i) = sum(AL_V(NotAL{i}).*Mu(NotAL{i}))/(AL_V(i)*Mu(i));
        end
    end
    if (min(AL_WD)==inf)
        break;
    end
    I = Allowed(find(min(AL_WD(Allowed))==AL_WD(Allowed)));
    I = I(1);
    LSet(I)=1;
    Set = [Set;I];
    Allowed = intersect(Allowed,AL{I});
    Allowed = Allowed(find(Allowed~=I));
    if (isempty(Allowed)==1)
        break;
    end
end

newV=MakeS(LSet,H,VScale);
for jj=1:size(S,1)
    if (norm(S(jj,:)-LSet)==0)
        newV=0*newV;
        break;
    end
end

if (newV*Mu > max(V*Mu))
    disp('kako found new assignment')
    SKako = LSet;
    VKako = newV;
%    S=[S;LSet];
 %   V=[V;newV];
    KakoSuc=1;
else
    disp('best assignment is not any better than what is currently used');
    KakoSuc=0;
    VKako=0;
    SKako=0;
end